#include <stdio.h>
#include <stdlib.h>


#include "lion.h"
#include "misc.h"

#include "dirlist_child.h"
#include "dirlist_child_userinput.h"
#include "dirlist_child_process.h"


int dirlist_child_userinput( lion_t *handle, void *user_data, 
							 int status, int size, char *line)
{

	switch ( status ) {

	case LION_PIPE_EXIT:
#ifdef DEBUG
		printf("  [dirlist_child] parent is gone, clean exit.\n");
#endif
		child_switch = 1;
		break;


	case LION_PIPE_FAILED:
#ifdef DEBUG
		printf("  [dirlist_child] parent %p failed! %d:%s\n",
			   handle, size, line);
#endif
		child_switch = 1;
		break;

	case LION_PIPE_RUNNING:
#ifdef DEBUG
		printf("  [dirlist_child] parent %p is running\n", handle);
#endif
		break;


	case LION_INPUT:
#ifdef DEBUG
		printf("  [dirlist_child] parent %p -> '%s'\n", handle, line);
#endif
		dirlist_child_parse(handle, line);

		break;

	case LION_BUFFER_USED:
#ifdef DEBUG
		printf("  [dirlist_child] buffering event ignored\n");
#endif
		break;


	default:
		break;


	}
	
	return 0;

}



void dirlist_child_parse( lion_t *reply, char *task)
{
	char *token, *ar;
	int id, flags, precat;

	// task = "<id> <flags> <path>" 
	ar = task;

	if (!(token = misc_digtoken(&ar, " "))) {
		lion_printf(reply, "0 -0 Parse Error: no id field\n");
		return;
	}

	id = atoi( token );

	if (!(token = misc_digtoken(&ar, " "))) {
		lion_printf(reply, "%u -0 Parse Error: no flags field\n",
					id);
		return;
	}

	flags = atoi( token );

	if (!(token = misc_digtoken(&ar, " "))) {
		lion_printf(reply, "%u -0 Parse Error: no precat field\n",
					id);
		return;
	}

	precat = atoi( token );

	// file name
#if 0
	if (!(token = misc_digtoken(&ar, " \""))) {
		lion_printf(reply, "%u -0 Parse Error: no path field\n",
					id);
		return;
	}
#endif
	// We KNOW the "ar" should have a space now (we control the send of this
	// string from parent after all) the rest is unknown, and may have spaces.
	//	printf("aaa ar is '%s' and precat %d\n", ar, precat);

	if (precat) {

#ifdef DEBUG
		if (ar[precat] != ' ')
			printf("[dirlist] Not a space at precat?\n");
#endif

		ar[precat] = 0;
		precat++;
	}

	// We have id, flags and path.

	dirlist_child_process(reply, id, flags, 
						  precat ? ar : "",
						  &ar[precat]);

}



