
#include <stdio.h>
#include <stdlib.h>



#include "lion.h"
#include "misc.h"

#include "queue.h"





dirlist_queue_t *queue_new( dirlist_queue_t **head, dirlist_queue_t **tail )
{
	dirlist_queue_t *que;

	if (!head || !tail)
		return NULL;


	que = (dirlist_queue_t *) malloc(sizeof(*que));
	memset(que, 0, sizeof(*que));

	// Insert at the tail end. if none there, make it us
	// if somethig is there, set its ->next
	if (*tail) 
		(*tail)->next = que;

	*tail = que;

	// if head is NULL, this is the new head too!
	if (!*head)
		*head = que;

	return que;
}


dirlist_queue_t *queue_pop( dirlist_queue_t **head, dirlist_queue_t **tail )
{
	dirlist_queue_t *que;

	if (!head || !tail)
		return NULL;

	// We take what head is pointing to,
	// and set head to its ->next.

	if (!*head) return NULL; // Empty

	que = *head;
	*head = que->next;  // Might be NULL, so its ok.

	if (*tail == que)
		*tail = que->next;

	return que;
}




void queue_free( dirlist_queue_t *node )
{

	if (!node) return;
	
	SAFE_FREE( node->path );
	SAFE_FREE( node->precat );
	SAFE_FREE( node->stop_msg );
	SAFE_FREE( node );

}

