// $Id: io.h,v 1.9 2005/05/25 12:33:38 lundman Exp $
// Core input output functions, the main select() call and misc connectivity
// Jorgen Lundman November 9th, 1999
// Copyright (c) 1999 HotGen Studios Ltd <www.hotgen.com>

#ifndef IO_H
#define IO_H


/* Includes */

#include <sys/types.h>
#include <time.h>

#ifdef WIN32
#define WINDOWS_LEAN_AND_MEAN
#include <winsock.h>
#else
#include <unistd.h>
#endif



/* Defines   */

#define  IO_TIMEOUT_USEC    0
#define  IO_TIMEOUT_SEC     30


#define IO_READFD  1
#define IO_WRITEFD 2
#define IO_BOTH    (IO_READFD | IO_WRITEFD)



/* Variables */
extern time_t io_global_time;




//extern THREAD_SAFE time_t io_global_time;
THREAD_SAFE extern int io_force_loop;


/* Functions */

int  io_add_to_fdset( int, int);
//int  io_loop(void);
void io_set_fdset( fd_set *fdset_read, fd_set *fdset_write );
void io_process_fdset( fd_set *fdset_read, fd_set *fdset_write );

void io_set_fdsetread( int );
void io_set_fdsetwrite( int );
int  io_isset_fdsetread( int );
int  io_isset_fdsetwrite( int );
int  io_near_full( void );

int  io_input           ( connection_t *);
int  io_getline         ( connection_t *, char **);

int io_set_fdset_sub    ( connection_t *, void *, void *);
int io_process_fdset_sub( connection_t *, void *, void *);
int io_purge_sub        ( connection_t *, void *, void *);
void io_pushread(void);
int io_passbinary(connection_t *);
void io_process_rate( void );

void io_release_all( connection_t * );

#ifdef WIN32
int io_isset_fdset( connection_t *, int);
void io_set_fdset_win32 ( connection_t *, int);

#endif


#endif




