/* Copyright (C) 1991, 1992, 1993 Free Software Foundation, Inc.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#ifndef	_LFNMATCH_H

#define	_LFNMATCH_H	1


/* Bits set in the FLAGS argument to `fnmatch'.  */
#define	LFNM_PATHNAME	(1 << 0) /* No wildcard can ever match `/'.  */
#define	LFNM_NOESCAPE	(1 << 1) /* Backslashes don't quote special chars.  */
#define	LFNM_PERIOD	(1 << 2) /* Leading `.' is matched only explicitly.  */

#define	LFNM_FILE_NAME	LFNM_PATHNAME /* Preferred GNU name.  */
#define	LFNM_LEADING_DIR	(1 << 3) /* Ignore `/...' after a match.  */
#define	LFNM_CASEFOLD	(1 << 4) /* Compare without regard to case.  */

/* Value returned by `fnmatch' if STRING does not match PATTERN.  */
#define	LFNM_NOMATCH	1

/* Match STRING against the filename pattern PATTERN,
   returning zero if it matches, FNM_NOMATCH if not.  */
extern int lfnmatch (const char *, const char *, int );

#endif /* fnmatch.h */


