// $Id: lgroup.h,v 1.4 2003/08/29 06:21:48 lundman Exp $
// Lgroup rate limits.
// Jorgen Lundman April 20th, 2003

#ifndef LGROUP_H
#define LGROUP_H

#include <time.h>  // for time_t
#include "lion.h"

/* Includes */



// Could make a smaller number, but the OS usually deal in page sizes so it
// might not be worth doing that anyway.
#define LGROUP_INCREMENT 256

// Lgroup 0 is special, all nodes belong to it as it is the global
// cap for the whole lion library.
#define LGROUP_GLOBAL 0





/* Variables */


struct lgroup_struct {
	unsigned int used;
	unsigned int cps_in;
	unsigned int cps_out;
	int current_in;
	int current_out;
	time_t stamp_in;
	time_t stamp_out;
};

typedef struct lgroup_struct lgroup_t;




/* Functions */

void     lgroup_exit            ( void );

int      lgroup_new             ( void );
void     lgroup_free            ( int );

void     lgroup_set_rate_in     ( int, int ); 
void     lgroup_set_rate_out    ( int, int ); 


// lion_t calls
void     lgroup_add             ( connection_t *, int );
void     lgroup_remove          ( connection_t *, int );

// Only makes sense once we have multi-lgroup code
//int      lgroup_ismember        ( lion_t *, int );

int      lgroup_check_rate_in   ( connection_t *, int );
int      lgroup_check_rate_out  ( connection_t *, int );

void     lgroup_add_in          ( connection_t *, int );
void     lgroup_add_out         ( connection_t *, int );


#endif
