#ifndef LION_RCSID_H_INCLUDED
#define LION_RCSID_H_INCLUDED


//
// Latestly, we define a way to make tags. This is done the same way NetBSD
// does it, only to be compatible. Aren't I nice.




// The Operating Systems that DON'T use gcc's "as" to link, we can not do
// the linking magic. So we just define it as a variable. But we make an 
// effort to try to hide the "variable not used" warning.


#if defined ( __sun__ ) || defined ( WIN32 )

//
// NOT GNU AS
//

# ifndef GCC_UNUSED
#  if __GNUC__ >= 2
#   if __GNUC__ == 2 && __GNUC_MINOR__ < 7
#    define GCC_UNUSED(decl) decl
#   else /* __GNUC__ == 2 && __GNUC_MINOR__ < 7 */
#    define GCC_UNUSED(decl) decl __attribute__((__unused__))
#   endif /* __GNUC__ == 2 && __GNUC_MINOR__ < 7 */
#  else /* __GNUC__ >= 2 */
#   define GCC_UNUSED(decl) decl
#  endif /* __GNUC__ >= 2 */
# endif /* SM_UNUSED */

#ifdef WIN32
#define GCC_UNUSED(X) X
#endif



# ifndef __RCSID
#  define __RCSID(str) GCC_UNUSED(static const char RcsId[]) = str;
# endif


#else // We can define it properly...


# ifndef __SECTIONSTRING

# if __STDC__
#   define __SECTIONSTRING(_sec, _str)                                     \
        __asm__(".section " #_sec " ; .asciz \"" _str "\" ; .text")
#  else
#   define __SECTIONSTRING(_sec, _str)                                     \
        __asm__(".section _sec ; .asciz _str ; .text")
#  endif

# endif // SECTIONSTRING

# ifndef __IDSTRING
#  define __IDSTRING(_n,_s)               __SECTIONSTRING(.ident,_s)
# endif

# ifndef __RCSID
#  define __RCSID(_s)                     __IDSTRING(rcsid,_s)
# endif



#endif // can define RCSID, has GNU AS.




#endif // INCLUDED
