#ifndef LION_TYPES_INCLUDED
#define LION_TYPES_INCLUDED


#ifdef WIN32
#define THREAD_SAFE __declspec(thread)
#else
#define THREAD_SAFE 
#endif



#if defined (__GNUC__)
typedef long long int lion64_t;
typedef unsigned long long int lion64u_t;
#elif defined (WIN32)
typedef __int64 lion64_t;
// Hah! error C2520: conversion from unsigned __int64 to double not implemented, use signed __int64
// So we make both be signed... but thats a bit crap.
typedef /* unsigned */ __int64 lion64u_t;
#else
#error ("unknown system?")
#endif

typedef lion64u_t bytes_t;


// Define the printable type. Unix std is from inttypes.h
#ifndef WIN32
#define __STDC_FORMAT_MACROS
#include <inttypes.h>
#endif


#ifdef WIN32
#ifndef PRIu64
#define PRIu64 "I64d"
#endif
#endif

#ifdef __FreeBSD__
#ifndef PRIu64
#define PRIu64 "qu"
#endif
#endif



#endif
