// $Id: misc.h,v 1.4 2005/07/27 07:19:29 lundman Exp $
// Miscellaneous utility functions
// Jorgen Lundman November 25th, 1999
// Copyright (c) 1999 HotGen Studios Ltd <www.hotgen.com>

#ifndef MISC_H
#define MISC_H

#include <time.h>

// Defines

// Various safe #defines.
#define SAFE_FREE(X) { if ((X)) { free((X)); (X) = NULL; } }
#define SAFE_COPY(X, Y) { SAFE_FREE(X); if ((Y)) (X) = strdup((Y)); }
#define SAFE_UCOPY(X, Y) { SAFE_FREE(X); if ((Y)) (X) = (unsigned char *)strdup((Y)); }
#define SAFE_DUPE(X, Y) { if ((Y)) (X) = strdup((Y)); else (X) = NULL; }
#define SAFE_PRINT(X) (X) ? (X) : ""

#define SAFE_STRNCPY(X, Y, N) { strncpy( (X), (Y), (N) ); (X)[(N)-1] = 0; }



// Variables

extern char misc_digtoken_optchar;



// Functions

char *misc_digtoken(char **, char *);
char *mystrcpy(char *);
int   misc_hextobin(char *);
int   misc_bintohex(char *, int);
char *misc_strdup(char *);
int   mystrccmp(char *,char *);
time_t misc_getdate(char *);
char *misc_idletime(time_t );
char *misc_idletime2(time_t );
char *misc_makepath(char *, char *);
char *misc_pasv2port(char *);
char *misc_strjoin(char *, char *);
int   misc_skipfile(char *, char *);
void  misc_stripslash(char *);
void  misc_undos_path(char *);
char *misc_strip(char *);
char *misc_url_encode(char *);
char *misc_url_decode(char *);


#endif

