
#ifndef OBJECT_H_INCLUDED
#define OBJECT_H_INCLUDED


#include "lion.h"


// **************
// Defines
// **************

//
// We demonstrate how you can have different "types" of nodes passed via
// user_data, and depending on their type, we call different functions.
//
enum object_type {
	OBJECT_TYPE_NONE,
	OBJECT_TYPE_LISTEN,
	OBJECT_TYPE_UNREGISTERED,
	OBJECT_TYPE_REGISTERED
};



// **************
// Variables
// **************

struct object_s {
	lion_t *handle;

	enum object_type type;

	unsigned long ip;
	unsigned int port;

	char *username;

	struct object_s *next;

};

typedef struct object_s object_t;





// **************
// Functions
// **************

object_t    *object_new        ( void );
void         object_free       ( object_t * );
void         object_free_all   ( void );
object_t    *object_find       ( int (*compare)(object_t *, void *, void *),
								 void *optarg1, void *optarg2 );

#endif
