#include <stdio.h>
#if __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif

#include "lion.h"

#include "object.h"

#include "say.h"








int say_all_sub( object_t *node, void *arg1, void *arg2 )
{
	// Out message should be in arg1, and strlen in arg2
	static char *line;
	static int len;
	
	if (!arg1 || !arg2)
		return 0; // 0 to abort iteration

	// Only say to registered connections
	if (node->type != OBJECT_TYPE_REGISTERED)
		return 1; // 1 to keep iterating.


	line = (char *) arg1;
	len = (int) arg2;

	lion_send(node->handle, line, len);

	return 1; // 1 to keep iterating.
}




//
// Send a string to a service
//
#if defined (__STDC__) || defined (WIN32)
int say_all(char const *fmt, ...)
#else
int say_all(fmt, va_alist)
     char const *fmt;
     va_dcl
#endif
{
  va_list ap;
  // Using a static buffer here is not ideal, but would be ok when
  // using "vsnprintf" - which is included with lion for Windows platforms.
  // Another option is using "lion_buffersize(YOUR_BUFFER_SIZE);" in your
  // main, then using that same value here.
  static char msg[4096];
  int result;

#if __STDC__ || WIN32
  va_start(ap, fmt);
#else
  va_start(ap);
#endif

  // Buffer overflow! No vsnprintf on many systems :(
  result = vsprintf(msg, fmt, ap);
  va_end(ap);


  result = strlen(msg);

  // Send it to all registered clients.
  object_find( say_all_sub, (void *)msg, (void *)result );

  // Tell console too. But \r\n makes double new line, so to make it
  // pretty, target and eliminate the "\r"
  if ((result > 2)  && 
	  (msg[ result - 2 ] == '\r'))
	  msg[ result - 2 ] = 0;

  puts(msg);

  return result;
                 
}

